#ifndef __ADC_H
#define __ADC_H

#include "ch32l103.h"
#include "ring_queue2.h"

//typedef struct _ADC_DATA {
//    uint16_t total_CHG_CURR;        /* һУadcɼֵ֮       */
//    uint16_t num_CHG_CURR;          /* һУadcɼ֮ */
//    uint16_t total_PV_VOLT_OUT;     /* ѹ */
//    uint16_t num_PV_VOLT_OUT;
//    uint16_t total_DSG_CURR;        /* ŵ */
//    uint16_t num_DSG_CURR;
//    uint16_t total_PV1_VOLT_IN;     /* ϵͳѹ */
//    uint16_t num_PV1_VOLT_IN;
//    uint16_t total_PV_VOLT_IN1;     /* ̫ܰѹ */
//    uint16_t num_PV_VOLT_IN1;
//    uint16_t total_MOSFET_Temper;   /* mos¶ */
//    uint16_t num_MOSFET_Temper;
//}ADC_DATA;

//#define data_len 50
//typedef struct _ADC_DATA {
//    uint16_t num;                           /* һУadcɼ */
//    uint16_t CHG_CURR_array[data_len];      /*  */
//    uint16_t PV_VOLT_OUT_array[data_len];   /* ѹ */
//    uint16_t DSG_CURR_array[data_len];      /* ŵ */
//    uint16_t PV_VOLT_IN_array[data_len];    /* ̫ܰѹ */
//    uint16_t SYS_VOLT_IN_array[data_len];   /* ϵͳѹ */
//    uint16_t MOSFET_Temper_array[data_len]; /* mos¶ */
//}ADC_DATA;

#define adcBuffSize 100

typedef struct _ADC_DATA {
    RingQueue2 RQCHG_CURR;
    uint32_t total_CHG_CURR;      /* һʱadcֵĺ */
    RingQueue2 RQDSG_CURR;
    uint32_t total_DSG_CURR;      /* ŵһʱadcֵĺ */
}ADC_DATA;

extern ADC_DATA g_adcData;
extern int16_t Calibrattion_Val;

void ADC_all_Init(void);
void ADC_TIM_DMA_Init(void);

#endif
